  MEMBER
  MAP
    MODULE( 'FakeCall' )
      UltraEventsProc,PASCAL,DLL(1)                         !This declares a fake procedure, to call dynamically
    END
  END

lUltraEventsProcedure   LONG,STATIC,NAME( 'UltraEventsProc' ) !THIS IS THE TRICK!
                                                            !Since the variable is bound
                                                            !to a fake procedure by the NAME
                                                            !When we call the fake procedure
                                                            !Clarion will load whathever is
                                                            !at that address... it's just a 
                                                            !question of changind the variable's
                                                            !contents before the call, hehehe
  
  INCLUDE( 'UltraEvents.inc' ),ONCE

UltraEvents.Construct         PROCEDURE
  CODE
  SELF.Q &= NEW( UltraEventsQ )                             !Creates de queue

UltraEvents.Destruct          PROCEDURE
  CODE
  DISPOSE( SELF.Q )                                         !Frees the memory allocated

UltraEvents.AddHotKey         PROCEDURE( LONG pHotKey, LONG pProcedure )
  CODE
  SELF.Q.hotkey = pHotKey 
  SELF.Q.procaddress = pProcedure
  ADD( SELF.Q )                                             !Creates the entry

UltraEvents.WATCH             PROCEDURE
  CODE
  LOOP i# = 1 TO RECORDS( SELF.Q )                          !Alerts every hotkey added
    GET( SELF.Q, i# )
    ALERT( SELF.Q.hotkey )
  END
  REGISTER( EVENT:AlertKey, ADDRESS( SELF.ProcessEvent ), ADDRESS( SELF ) ) !Registers the method that proccesses the event

UltraEvents.ProcessEvent      PROCEDURE
  CODE
  SELF.Q.hotkey = KEYCODE()                                 !Captures the keycode
  GET( SELF.Q, SELF.Q.hotkey )
  IF NOT ERROR()
    lUltraEventsProcedure = SELF.Q.procaddress              !Load the procedure address
    UltraEventsProc                                         !Call the "fake" procedure, which is directed to the desired one
  END
  RETURN 0                                                  !This ensures any further processing happens
